class AppDatabase {
  String appDatabase = "";

  AppDatabase() {
    appDatabase += "import 'dart:async';\n";
    appDatabase += "import 'package:path/path.dart';\n";
    appDatabase += "import 'package:path_provider/path_provider.dart';\n";
    appDatabase += "import 'package:sembast/sembast.dart';\n";
    appDatabase += "import 'package:sembast/sembast_io.dart';\n";

    appDatabase += "class AppDatabase {\n";
    appDatabase +=
        " static final AppDatabase _singleton = AppDatabase._();\n\n";

    appDatabase += " static AppDatabase get instance => _singleton;\n\n";

    appDatabase += " Completer<Database> _dbOpenCompleter;\n\n";

    appDatabase += "  AppDatabase._();\n\n";

    appDatabase += "  DatabaseClient _database;\n\n";

    appDatabase += "  Future<DatabaseClient> get database async {\n";
    appDatabase += "    if (_dbOpenCompleter == null) {\n";
    appDatabase += "      _dbOpenCompleter = Completer();\n";
    appDatabase += "      _openDatabase();\n";
    appDatabase += "    }\n";
    appDatabase += "    return _dbOpenCompleter.future;\n";
    appDatabase += "  }\n\n";

    appDatabase += "  Future _openDatabase() async {\n";
    appDatabase +=
        "    final appDocumentDir = await getApplicationDocumentsDirectory();\n";
    appDatabase +=
        "    final dbPath = join(appDocumentDir.path, 'appDatabase.db');\n";

    appDatabase +=
        "    final database = await databaseFactoryIo.openDatabase(dbPath);\n";
    appDatabase += "    _dbOpenCompleter.complete(database);\n";
    appDatabase += "  }\n";
    appDatabase += "}\n";
  }
}
